<?
/**
 *   .
 */

class HTMLMethods {
   function domainName () { global $SERVER_NAME;
       if (isset($SERVER_NAME)) return str_replace('www.', '', $SERVER_NAME);
       else return '';
   }

   function addZerosToReach8Chars ($number) {
        $zeros = '';
        for ($cntr = 0; $cntr < 8 - strlen($number); $cntr ++) $zeros .= '0';

        $result = (string) $zeros.$number;
        return $result;
   }

   function getPointerPath($show) {
       $evil_hacker_gimmick = '..'; $strong_admin_protection = '.';
       $show = str_replace ($evil_hacker_gimmick, $strong_admin_protection, $show);

       $show = str_replace ('.', '/', $show);
       $show = str_replace (' ', '_', $show);

       $show = str_replace (')', '', $show);
       $show = str_replace ('(', '', $show);

       $show = $this->_correctFileName ($show);
       $show = $this->delDoubleSpaces ($show);

       return $show;
   }

   function _correctFileName ($file_name) {
       return str_replace ('//', '/', $file_name);
   }

   function title ($show) { global $current_path;
       $title_file = $this->resolveTitleFile ($show);

       if (file_exists ($title_file)) {
           $file = fopen ($title_file, 'r');
           $title = fread ($file, filesize ($title_file));
           fclose ($file); unset ($file);

           return trim (strip_tags ($title));
       }

       return '';
   }

   function resolveTitleFile ($show) { global $current_path;
       return $this->_resolveFile ($show, 'title');
   }

   function resolveDateFile ($show) { global $current_path;
       return $this->_resolveFile ($show, 'date');
   }

   function _resolveFile ($show, $suffix) { global $current_path;
       $name = $this->getPointerPath ($show);

       for($step_cntr = 0; $step_cntr < 2; $step_cntr ++) {
           $extension = 'php';

           for ($ext_cntr = 0; $ext_cntr < 2; $ext_cntr ++) {
                $level = '';

                for ($level_cntr = 0; $level_cntr < 2; $level_cntr ++) {
                     $pointer = $current_path.$name.$level.'/'.$suffix.'.'.$extension;
                     if (file_exists ($pointer)) { $file_name = $pointer; break; }

                     $pointer = $current_path.$name.'_'.$suffix.'.'.$extension;
                     if (file_exists ($pointer)) { $file_name = $pointer; break; }

                     if (strstr ($name, '_txt')) {
                         $pointer = $current_path.str_replace ('_txt', '_'.$suffix, $name).'.'.$extension;
                         if (file_exists ($pointer)) { $file_name = $pointer; break; }
                     }

                     $level = '/..';
                }
                if ($file_name) break;

                $extension = 'txt';
           }
           if ($file_name) break;

           $name = 'db/'.$name;
       }

       return $file_name;
   }

   function makePointer ($show) {
       $name = str_replace ('/', '.', $show);
       if (substr ($name, 0, 3) == 'db.') $name = substr ($name, 3);

       return $name;
   }

   function resolvePointer ($show) { global $current_path;
       $name = $this->getPointerPath ($show);

       $pointer = $current_path.'db/'.$name.'.php';
       if (file_exists ($pointer)) $name = 'db/'.$name;

       $pointer = $current_path.'db/'.$name.'.txt';
       if (file_exists ($pointer)) $name = 'db/'.$name;

       $pointer = $current_path.'db/'.$name.'.jpg';
       if (file_exists ($pointer)) $name = 'db/'.$name;

       $pointer = $current_path.'db/'.$name.'.png';
       if (file_exists ($pointer)) $name = 'db/'.$name;

       $pointer = $current_path.'db/'.$name.'.gif';
       if (file_exists ($pointer)) $name = 'db/'.$name;

       $pointer = $current_path.'db/'.$name.'.swf';
       if (file_exists ($pointer)) $name = 'db/'.$name;

       return $name;
   }

   function txt ($name) { global $current_path;
       $file_name = $this->_correctFileName ($current_path.$name);
       if (!file_exists ($file_name)) return '';

       if (strstr ($name, '.php') || strstr ($name, '.txt')) {
           $file = fopen ($file_name, 'r');
           $text = fread ($file, filesize ($file_name));
           fclose ($file); unset ($file);

           return trim (strip_tags ($text));
       }

       return '';
   }

   function img ($name, $prp = '', $max_width = 0) { global $current_path;
       $file_name = $this->_correctFileName ($current_path.$name);
       if (!file_exists ($file_name)) return '<!-- Not found: '.$name.' -->';

       if (strstr ($name, '.swf')) {
           $string = '<object '.$prp.'><param name="movie" value="'.$name.'">'."\n";
           $string = '<embed type="application/x-shockwave-flash" src="'.$name.'" '.$prp.'></embed>'."\n";
           $string = '</object>';

           return $string;
       }

       if ($prp != '' && !strpos ($prp, '=')) $prp = 'alt="'.$this->delPunctuationMarks ($prp).'"';

       $image_size_string = '';
       if (!$prp || !strstr ($prp, 'width')) $image_size_string = ' '.$this->_imageSize ($file_name, $max_width);

       $image_border_string = '';
       if (!$prp || !strstr ($prp, 'border')) $image_border_string = 'border=0';

       if (!$prp || !strstr ($prp, 'alt=')) {
           $alt_text = $this->_imageAltText($file_name);
           if ($alt_text) $prp .= ' alt="'.$alt_text.'"';
       }

       $transfer_script = 'transfer.php';
       if (!file_exists ($current_path.$transfer_script)) $transfer_script = '';

       if ($transfer_script) $name = $transfer_script.'?request='.base64_encode ($name);

       $string = '<img src="'.$name.'" '.$image_size_string.' ';
       $string .= $image_border_string.' ';
       if ($prp != '') $string .= $prp.' ';
       $string .= '>';

       return $string;
   }

   function imgSize ($name, $max_width = 0) { global $current_path;
       $file_name = $this->_correctFileName ($current_path.$name);
       if (!file_exists ($file_name)) return '[img_not_found:'.$file_name.']';

       return $this->_imageSize ($file_name, $max_width);
   }

   function _imageSize ($file_name, $max_width = 0) { global $rexx, $current_path;
       $size = getimagesize ($file_name);

       if ($max_width <= 0) return $size[3];

       $values = $rexx->parse ($size[3], 'width="', '" height="', '"');

       $width = $values[0];
       $height = $values[1];

       if ($width > $max_width) {
           $scale_factor = $width / $max_width;

           $height = round ($height / $scale_factor);
           $width = $max_width;
       }

       return 'width='.$width.' height='.$height;
   }

   function _imageAltText ($file_name) { global $show, $current_path;
       $alt_text = '';

       $fn_we = '';

       if (strpos ($file_name, '.jpg')) $fn_we = str_replace ('.jpg', '', $file_name);
       if (strpos ($file_name, '.png')) $fn_we = str_replace ('.png', '', $file_name);
       if (strpos ($file_name, '.gif')) $fn_we = str_replace ('.gif', '', $file_name);

       $title_file = '';

       for ($cntr = 0; $cntr < 2; $cntr ++) {
            $title_file = $fn_we.'_alt.php';   if (file_exists ($title_file)) break;
            $title_file = $fn_we.'_alt.txt';   if (file_exists ($title_file)) break;
            $title_file = $fn_we.'_title.php'; if (file_exists ($title_file)) break;
            $title_file = $fn_we.'_title.txt'; if (file_exists ($title_file)) break;
            $title_file = $fn_we.'_h.php';     if (file_exists ($title_file)) break;
            $title_file = $fn_we.'_h.txt';     if (file_exists ($title_file)) break;

            $title_file = $fn_we.'.alt';       if (file_exists ($title_file)) break;
            $title_file = $fn_we.'.php';       if (file_exists ($title_file)) break;
            $title_file = $fn_we.'.txt';       if (file_exists ($title_file)) break;

            $title_file = '';

            if ($cntr == 0) {
                $fn_wp = substr ($fn_we, strrpos ($fn_we, '/') + 1);

                if (strpos ($fn_wp, '_')) {
                    $fn_we = substr ($fn_we, 0, strrpos ($fn_we, '_'));
                    continue;
                }
            }
       }

       if (!$title_file) {
           $fp_wn = $file_name;
           $max_levels_for_embedded_gallery = 3;

           for ($cntr = 0; $cntr < $max_levels_for_embedded_gallery; $cntr ++) {
                $fp_wn = substr ($fp_wn, 0, strrpos ($fp_wn, '/'));

                $title_file = $fp_wn.'/title.php'; if (file_exists ($title_file)) break;
                $title_file = $fp_wn.'/title.txt'; if (file_exists ($title_file)) break;

                $title_file = '';
           }
       }

       if (!$title_file && isset ($show)) {
           $title_file = $this->resolveTitleFile ($show);
       }

       if ($title_file) {
           $title_file = str_replace ($current_path, '', $title_file);
           $alt_text = $this->delPunctuationMarks ($this->txt ($title_file));
       }

       return $alt_text;
   }

   function extension ($image_file_or_mime_type) {
       $image_file_or_mime_type = strtolower ($image_file_or_mime_type);

       $ext = '.jpg';
       if (strstr ($image_file_or_mime_type, 'png')) $ext = '.png';
       if (strstr ($image_file_or_mime_type, 'gif')) $ext = '.gif';

       return $ext;
   }

   function findImgFile ($show) { global $current_path;
       $name = $this->getPointerPath ($show);

       for($cntr = 0; $cntr < 2; $cntr ++) {
           $pointer = $name.'.jpg';
           if (file_exists ($current_path.$pointer)) { $file_name = $pointer; break; }

           $pointer = $name.'.png';
           if (file_exists ($current_path.$pointer)) { $file_name = $pointer; break; }

           $pointer = $name.'.gif';
           if (file_exists ($current_path.$pointer)) { $file_name = $pointer; break; }

           $name = 'db/'.$name;
       }

       return $file_name;
   }

   function nl2br ($string) {
       return str_replace ('<br />', '<br>', nl2br ($string));
   }

   function win2koi ($string) {
       $win = 'Ũ';
       $koi = 'ţ .-----""""""""""';

       return strtr ($string, $win, $koi);
   }

   function lowerCase ($string) {
       return $this->_changeCase ($string, 'L');
   }

   function upperCase ($string) {
       return $this->_changeCase ($string, 'U');
   }

   function mixedCase ($string) {
       $string = $this->lowerCase ($string);
       $string = $this->upperCase (substr ($string, 0, 1)).substr ($string, 1);

       return $string;
   }

   function _changeCase ($string, $direction) {
       $upper_case = 'ABCDEFGHIJKLMNOPQRSTUVWXYZŨ';
       $lower_case = 'abcdefghijklmnopqrstuvwxyz';

       if ($direction == 'L') return strtr ($string, $upper_case, $lower_case);
       if ($direction == 'U') return strtr ($string, $lower_case, $upper_case);

       return '';
   }

   function randomSequence () {
       srand ((double) microtime () * 1024);

       $sequence = '';
       while (strlen ($sequence) < 10) {
              $symb = ord ('9') + 1;
              while (($symb > ord ('9') && $symb < ord ('A')) || 
                     ($symb > ord ('Z') && $symb < ord ('a'))) {
                      $symb = rand (ord ('0'), ord ('z'));
              }
              $sequence .= chr ($symb);
       }

       return $sequence;
   }

   function delPunctuationMarks ($string) {
       $pattern = '~`!@#$%^&*()-_=+[]{};:"|,.<>/?';
       $replace = '                              ';

       $string = strtr ($string, $pattern, $replace);
       $string = strtr ($string, '\'\\', '  ');

       $string = str_replace ("\b", ' ', $string);
       $string = str_replace ("\t", ' ', $string);
       $string = str_replace ("\n", ' ', $string);
       $string = str_replace ("\v", ' ', $string);
       $string = str_replace ("\f", ' ', $string);
       $string = str_replace ("\r", ' ', $string);

       $string = $this->delDoubleSpaces ($string);

       return $string;
   }

   function delNumbers ($string) {
       $pattern = '0123456789';
       $replace = '          ';

       $string = strtr ($string, $pattern, $replace);

       $string = $this->delDoubleSpaces ($string);

       return $string;
   }

   function delSpacesAndBreaks ($string) {
         $symbols = '';
         $hollows = '';

         for ($cntr = 0; $cntr < ord (' '); $cntr ++) {
              $symbols .= chr ($cntr);
              $hollows .= ' ';
         }

         return str_replace (' ', '', strtr ($string, $symbols, $hollows));
   }

   function delDoubleSpaces ($string) {
       for ($cntr = 0; $cntr < 100; $cntr ++) {
            $new_string = trim (str_replace ('  ', ' ', $string));

            if ($new_string != $string) $string = $new_string;
            else break;
       }

       return $string;
   }

   function delHtmlTags ($string) {
       $pattern = '<>';
       $replace = '[]';

       return strtr ($string, $pattern, $replace);
   }

   function encodeCorners ($string) {
       return str_replace ('>', '&gt;', str_replace ('<', '&lt;', $string));
   }

   function stripExtension ($file_name) {
         $splitter = '.';
         $first_token = strtok ($file_name, $splitter);

         return $first_token;
   }

   function alert ($text) {
       print '<script>alert ("'.$text.'");</script>';
   }

   function redirect ($location) {
       print '<script>location.href="'.$location.'";</script>';
   }

   function goBack () {
       print '<script>history.back();</script>';
   }

   function jumpBack ($steps) {
       if ($steps) print '<script>history.go(-'.$steps.');</script>';
   }

   function download ($remote_file_name) {
       $lines = file ($remote_file_name);
       if (!$lines) return '';

       return trim (join ('', $lines));
   }

   function downloadLines ($remote_file_name) {
       $lines = file ($remote_file_name);
       if (!$lines) return '';

       $content = '';
       for ($cntr = 0; $cntr < count ($lines); $cntr ++) {
            $line = trim ($lines [$cntr]);
            if ($line) $content .= $line."\n\n";
       }

       return trim ($content);
   }
}

$methods = new HTMLMethods ();
?>