<?
/**
 *          SQL.
 *
 *   "permanent connection"         .
 *   , ,  -         .
 *
 *   "disconnect"  .
 *
 */

class DBManager {

   function DBManager () {
         $mysql_extension_is_available = mysql_errno ();
   }

   function connect ($db_user = '', $db_pass = '', $db_name = '') { global $config;
         if (!$db_user) $db_user = $config->param ('db_user');
         if (!$db_pass) $db_pass = $config->param ('db_pass');
         if (!$db_name) $db_name = $config->param ('db_name');

         $mysql_host = $config->param ('mysql_host');
         $mysql_port = $config->param ('mysql_port');

         $link = '';

         if ($mysql_host && $mysql_host != '127.0.0.1' && $mysql_host != 'localhost') {
             $link = @mysql_connect ($mysql_host.':'.$mysql_port, $db_user, $db_pass); $this->_catchException ();
         } else {
             $link = @mysql_connect ('', $db_user, $db_pass); $this->_catchException ();
         }

         if ($link) {
             @mysql_select_db ($db_name, $link); $this->_catchException ();
         }
   }

   function query ($sql) {
         $is_show_select = $this->_isShowSelect ($sql); 
         if (!$is_show_select) { print '/SQL!S/'; exit; }

         $this->_detectSQLInjection ($sql, $is_show_select);

         $res = @mysql_query ($sql); $this->_catchException ($sql);

         return $res;
   }

   function execute ($sql) {
         $is_show_select = $this->_isShowSelect ($sql); 
         if ($is_show_select) { print '/SQL!E/'; exit; }

         $this->_detectSQLInjection ($sql, $is_show_select);

         $res = @mysql_query ($sql); $this->_catchException ($sql, 'CRITICAL');

         return $res;
   }

   function rows ($res) {
         if (!$res) return '';

         $rows = @mysql_num_rows ($res); if (!$rows) $rows = 0;

         return $rows;
   }

   function fetch ($res) {
         if (!$res) return '';

         $description = @mysql_fetch_object ($res); if (!$description) $description = '';

         return $description;
   }

   function disconnect () {
         for ($cntr = 0; $cntr < 10; $cntr ++) @mysql_close ();
   }

   function _detectSQLInjection ($sql, $is_show_select) { global $methods, $debug;
         if (!isset ($methods)) exit;
         if (!$sql) return;

         $string = $sql;
         $string = $methods->delSpacesAndBreaks ($string);
         $string = str_replace ('"',  '`', $string);
         $string = str_replace ('\'', '`', $string);

         if (!$is_show_select && $this->_isDelete ($sql)) {
             $hacker_injection = '--'; if (strpos (' '.$string, $hacker_injection)) { print '/SQL!-/'; if ($debug) print "\n".$sql."\n".'/'; exit; }
             $hacker_injection = '/*'; if (strpos (' '.$string, $hacker_injection)) { print '/SQL!-/'; if ($debug) print "\n".$sql."\n".'/'; exit; }

             $hacker_injection = ';';  if (strpos (' '.$string, $hacker_injection)) { print '/SQL!;/'; if ($debug) print "\n".$sql."\n".'/'; exit; }

             $hacker_injection = '``'; if (strpos (' '.$string, $hacker_injection)) { print '/SQL!"/'; if ($debug) print "\n".$sql."\n".'/'; exit; }
         }

         $string = strtolower ($string);

         if (strpos (' '.$string, 'where')) {
             $string = substr ($string, strpos ($string, 'where'));

             if ($is_show_select) {
                 $table_join = 'id='; $string = str_replace ($table_join, 'id&', $string);
             }

             $b64_chars = '=='; $string = str_replace ($b64_chars, '++', $string);

             $eq = '=`';  $string = str_replace ($eq, '*`', $string);
             $ne = '<>`'; $string = str_replace ($ne, '*`', $string);

             $gt = '>`';   $string = str_replace ($gt, '*`',  $string);
             $gt = '>=`';  $string = str_replace ($gt, '*=`', $string);
             $lt = '<`';   $string = str_replace ($lt, '*`',  $string);
             $lt = '<=`';  $string = str_replace ($lt, '*=`', $string);

             if (strpos (' '.$string, '=')) { print '/SQL!&/'; if ($debug) print "\n".$sql."\n".'/'; exit; }
             if (strpos (' '.$string, '>')) { print '/SQL!&/'; if ($debug) print "\n".$sql."\n".'/'; exit; }
             if (strpos (' '.$string, '<')) { print '/SQL!&/'; if ($debug) print "\n".$sql."\n".'/'; exit; }
         }
   }

   function _isShowSelect ($sql) {
         return $this->_isSIUD ($sql, 'S');
   }

   function _isInsert ($sql) {
         return $this->_isSIUD ($sql, 'I');
   }

   function _isUpdate ($sql) {
         return $this->_isSIUD ($sql, 'U');
   }

   function _isDelete ($sql) {
         return $this->_isSIUD ($sql, 'D');
   }

   function _isSIUD ($sql, $criteria) { global $methods;
         if (!isset ($methods)) exit;

         if ($sql && $criteria) {
             $sql = strtoupper ($methods->delSpacesAndBreaks ($sql));
             if ($sql && $sql[0] == $criteria) return 1;
         } 

         return 0;
   }

   function _catchException ($sql = '', $critical = '') { global $debug;

         if ($debug && @mysql_errno ()) {
             print '<br><pre><font color=red>';
             print @mysql_error (); if ($sql) print "\n".$sql;
             print '</font></pre><br>';

             if ($critical) exit (0);
         }

   }

}

$db = new DBManager ();
?>