<?
/**
 *   $query          .
 *
 *  ,      "a=b&c=d",  :
 *          <a href="index.php<?= $query->stringFor ('key'); ?>key=123"></a>
 *    :
 *          <a href="index.php?a=b&c=d&key=123"></a>
 *
 *          : "<input type=hidden name=... value=...>".
 *
 *    "setParameter ()"    PHP,   ,
 *     Perl,   "$q->param ()",    PHP-.
 *
 *    $query  "$QUERY_STRING"  "$HTTP_..._VARS"   "array ()".
 *
 *    "parameters_to_delete"  ,    
 *    .
 *
 */

class HTMLQuery {

    function HTMLQuery () { global $HTTP_GET_VARS, $HTTP_POST_VARS, $HTTP_COOKIE_VARS,
                                   $HTTP_POST_FILES, $QUERY_STRING, $HTTP_SERVER_VARS,
                                   $SERVER_NAME, $PHP_SELF,
                                   $REMOTE_ADDR, $HTTP_USER_AGENT, $HTTP_REFERER,
                                   $PHP_AUTH_USER, $PHP_AUTH_PW;

        $this->{'data'}->{'parameters_to_delete'} = array ();
        $this->{'data'}->{'parameters_to_delete'}[] = 'hotlog';
        $this->{'data'}->{'parameters_to_delete'}[] = 'spylog';

        for ($cntr = 0; $cntr < 3; $cntr ++) {
             switch ($cntr) {
                     case 0: $variable_list = $HTTP_GET_VARS;    break;
                     case 1: $variable_list = $HTTP_POST_VARS;   break;
                     case 2: $variable_list = $HTTP_COOKIE_VARS; break;
             }

             if (isset ($variable_list) && count ($variable_list)) {
                 reset ($variable_list);
                 while (list ($name, $value) = each ($variable_list)) {
                        $this->setParameter ($name, $value);
                 }
             }
        }

        if (isset ($HTTP_POST_FILES)) {
            reset ($HTTP_POST_FILES);
            while (list ($name, $value) = each ($HTTP_POST_FILES)) {
                   $this->setParameter ($name.'_name', $HTTP_POST_FILES[$name]['name']);
                   $this->setParameter ($name.'_type', $HTTP_POST_FILES[$name]['type']);
                   $this->setParameter ($name.'_size', $HTTP_POST_FILES[$name]['size']);

                   $this->setParameter ($name, $HTTP_POST_FILES[$name]['tmp_name']);
            }
        }

        if (isset ($QUERY_STRING)) {
            $parameters = preg_split ("/&/", $QUERY_STRING);

            foreach ($parameters as $parameter) {
                 if ($parameter) {
                     $tokens = preg_split ("/=/", $parameter);

                     if ($tokens[0]) $this->setParameter ($tokens[0], $tokens[1]);
                 }
            }
        }

        if (isset ($HTTP_SERVER_VARS)) {

            if ($HTTP_SERVER_VARS['SERVER_NAME'])     $SERVER_NAME     = $HTTP_SERVER_VARS['SERVER_NAME'];
            if ($HTTP_SERVER_VARS['PHP_SELF'])        $PHP_SELF        = $HTTP_SERVER_VARS['PHP_SELF'];

            if ($HTTP_SERVER_VARS['REMOTE_ADDR'])     $REMOTE_ADDR     = $HTTP_SERVER_VARS['REMOTE_ADDR'];
            if ($HTTP_SERVER_VARS['HTTP_USER_AGENT']) $HTTP_USER_AGENT = $HTTP_SERVER_VARS['HTTP_USER_AGENT'];
            if ($HTTP_SERVER_VARS['HTTP_REFERER'])    $HTTP_REFERER    = $HTTP_SERVER_VARS['HTTP_REFERER'];

            if ($HTTP_SERVER_VARS['PHP_AUTH_USER'])   $PHP_AUTH_USER   = $HTTP_SERVER_VARS['PHP_AUTH_USER'];
            if ($HTTP_SERVER_VARS['PHP_AUTH_PW'])     $PHP_AUTH_PW     = $HTTP_SERVER_VARS['PHP_AUTH_PW'];

        }

        if (isset ($PHP_SELF)) {
            $PHP_SELF = str_replace('\\', '/', $PHP_SELF);
            $PHP_SELF = str_replace('\\\\', '/', $PHP_SELF);

            if (strrchr ($PHP_SELF, '/')) $PHP_SELF = substr (strrchr ($PHP_SELF, '/'), 1);
            if (!strstr ($PHP_SELF, '.php')) $PHP_SELF = '';
        }

        $HTTP_GET_VARS = $HTTP_POST_VARS = $HTTP_COOKIE_VARS = array ();
        $HTTP_POST_FILES = $HTTP_SERVER_VARS = array ();
    }

    function string () {
        if (!isset($this->{'data'}->{'query_names'})) return '';

        return '?'.$this->_combineFor ('*');
    }

    function stringFor ($names) { global $current_path;
        if (!isset($this->{'data'}->{'query_names'})) return '?';

        $settings_file = $current_path.'include/settings/temporary_query_names.php';
        if (file_exists ($settings_file)) include ($settings_file);
        if ($document->{'temporary_query_names'}) $names .= ' | '.$document->{'temporary_query_names'};

        $new_string = $this->_combineFor ($this->_splitNames ($names));

        return $this->_addQueryMarks ($new_string);
    }

    function stringWith ($names) {
        if (!isset($this->{'data'}->{'query_names'})) return '?';

        $new_string = $this->_combineWithOnly ($this->_splitNames ($names));

        return $this->_addQueryMarks ($new_string);
    }

    function _addQueryMarks ($string) {
        if ($string) {
            if (substr ($string, -1) != '&') $string .= '&';
            return '?'.$string;
        }

        return '?';
    }

    function stringWithPermanentNames () { global $current_path;
        $settings_file = $current_path.'include/settings/permanent_query_names.php';
        if (file_exists ($settings_file)) include ($settings_file);

        if ($document->{'permanent_query_names'}) return $this->stringWith ($document->{'permanent_query_names'});

        return '?';
    }

    function fields () {
        if (!isset($this->{'data'}->{'query_names'})) return '';

        return $this->_makeFieldsFor ('*');
    }

    function fieldsFor ($names) { global $current_path;
        if (!isset($this->{'data'}->{'query_names'})) return '';

        $settings_file = $current_path.'include/settings/temporary_query_names.php';
        if (file_exists ($settings_file)) include ($settings_file);
        if ($document->{'temporary_query_names'}) $names .= ' | '.$document->{'temporary_query_names'};

        return $this->_makeFieldsFor ($this->_splitNames ($names));
    }

    function fieldsWith ($names) {
        if (!isset($this->{'data'}->{'query_names'})) return '';

        return $this->_makeFieldsWithOnly ($this->_splitNames ($names));
    }

    function fieldsWithPermanentNames () { global $current_path;
        $settings_file = $current_path.'include/settings/permanent_query_names.php';
        if (file_exists ($settings_file)) include ($settings_file);

        if ($document->{'permanent_query_names'}) return $this->fieldsWith ($document->{'permanent_query_names'});

        return '?';
    }

    function _getGlobalVariable ($name) {
        $value = '';

        eval ('global $'.$name.';');
        eval ('$'.'value'.'='.'$'.$name.';');

        return $value;
    }

    function _setGlobalVariable ($name, $value) {

        $length = strlen ($name);
        for ($cntr = 0; $cntr < $length; $cntr ++) {
             if ($name[0] == '$') $name = substr ($name, 1);
             else break;
        }

        $var_name = $name;
        if (strpos ($name, '->')) {
            $var_name = substr ($name, 0, strpos ($name, '->'));
        }

        $name = $this->_normalizeString ($name);
        $value = $this->_normalizeString ($value);

        eval ('global $'.$var_name.';');
        eval ('$'.$name.'=\''.$value.'\';');
    }

    function _normalizeString ($string) {
        $string = str_replace ('\"', '"', $string);

        $hacker_trap = '<?'; $string = str_replace ($hacker_trap, '<', $string);
        $hacker_trap = '?>'; $string = str_replace ($hacker_trap, '>', $string);

        return $string;
    }

    function _removeGlobalVariable ($name) {
        $this->_setGlobalVariable ($name, '');
    }

    function _splitNames ($names) {
        $tokens = array ();

        $splitters = ' ,;|&';
        $token = strtok ($names, $splitters);
        while ($token) {
               $token = trim ($token);

               if ($token) $tokens[] = $token;
               $token = strtok ($splitters);
        }

        return $tokens;
    }

    function _combineFor ($tokens) {
        if (!$tokens || !count ($tokens)) $tokens = array ();

        $string = ''; $length = count ($this->{'data'}->{'query_names'});
        $tokens_quantity = count ($tokens);

        for ($cntr = 0; $cntr < $length; $cntr ++) {
            if (!$this->_parameterIsSet ($cntr)) continue;
            if ($this->_presentInTokens ($this->{'data'}->{'query_names'}[$cntr], $tokens, $tokens_quantity)) continue;

            $string .= $this->{'data'}->{'query_names'}[$cntr].'='.urlencode ($this->{'data'}->{'query_values'}[$cntr]);

            if (substr ($string, -1) != '&') $string .= '&';
        }

        return $string;
    }

    function _combineWithOnly ($tokens) {
        if (!$tokens || !count ($tokens)) $tokens = array ();

        $string = ''; $length = count ($this->{'data'}->{'query_names'});
        $tokens_quantity = count ($tokens);

        for ($cntr = 0; $cntr < $length; $cntr ++) {
            if (!$this->_parameterIsSet ($cntr)) continue;

            if ($this->_presentInTokens ($this->{'data'}->{'query_names'}[$cntr], $tokens, $tokens_quantity)) {
                if ($string) $string .= '&';
                $string .= $this->{'data'}->{'query_names'}[$cntr].'='.urlencode( $this->{'data'}->{'query_values'}[$cntr]);
            }
        }

        return $string;
    }

    function _makeFieldsFor ($tokens) {
        if (!$tokens || !count ($tokens)) $tokens = array ();

        $string = ''; $length = count ($this->{'data'}->{'query_names'});
        $tokens_quantity = count ($tokens);

        for ($cntr = 0; $cntr < $length; $cntr ++) {
            if (!$this->_parameterIsSet ($cntr)) continue;
            if ($this->_presentInTokens ($this->{'data'}->{'query_names'}[$cntr], $tokens, $tokens_quantity)) continue;

            $string .= '<input type=hidden name="'.$this->{'data'}->{'query_names'}[$cntr].'" value="'.$this->{'data'}->{'query_values'}[$cntr].'">';
            $string .= "\n";
        }

        return $string;
    }

    function _makeFieldsWithOnly ($tokens) {
        if (!$tokens || !count ($tokens)) $tokens = array ();

        $string = ''; $length = count ($this->{'data'}->{'query_names'});
        $tokens_quantity = count ($tokens);

        for ($cntr = 0; $cntr < $length; $cntr ++) {
            if (!$this->_parameterIsSet ($cntr)) continue;

            if ($this->_presentInTokens ($this->{'data'}->{'query_names'}[$cntr], $tokens, $tokens_quantity)) {
                $string .= '<input type=hidden name="'.$this->{'data'}->{'query_names'}[$cntr].'" value="'.$this->{'data'}->{'query_values'}[$cntr].'">';
                $string .= "\n";
            }
        }

        return $string;
    }

    function _parameterIsSet ($position) {
        if ($position > count ($this->{'data'}->{'query_names'}) - 1) return 0;

        if ($this->{'data'}->{'query_names'}[$position] && $this->{'data'}->{'query_values'}[$position] != '') return 1;
        else return 0;
    }

    function _presentInTokens ($name, $tokens, $tokens_quantity) {
        for ($token_cntr = 0; $token_cntr < $tokens_quantity; $token_cntr ++) {
             if ($name[0] != '$' && $tokens[$token_cntr] == $name) return 1;
             if ($name[0] == '$' && $tokens[$token_cntr] == substr ($name, 1, strlen ($tokens[$token_cntr]))) return 1;
        }

        return 0;
    }

    function setParameter ($name, $value) {
        if (!isset($this->{'data'}->{'query_names'})) {
            $this->{'data'}->{'query_names'} = array ();
            $this->{'data'}->{'query_values'} = array ();
        }

        for ($cntr = 0; $cntr < count ($this->{'data'}->{'parameters_to_delete'}); $cntr ++) {
             if ($name == $this->{'data'}->{'parameters_to_delete'}[$cntr]) {
                 $this->_removeGlobalVariable ($name);
                 return;
             }
        }

        $name = urldecode ($name);   if ($name[0] == '@') $name = pack('H*', substr ($name, 1));
        $value = urldecode ($value); if ($value[0] == '@') $value = pack('H*', substr ($value, 1));

        if (!$this->_parameterIsCorrect ($name, $value)) {
            $this->_removeGlobalVariable ($name);
            return;
        }

        $position = $this->_position($name);

        if ($position != -1) {
            $this->{'data'}->{'query_values'}[$position] = $value;
        } else {
            $position = count ($this->{'data'}->{'query_names'});

            $this->{'data'}->{'query_names'}[$position] = $name;
            $this->{'data'}->{'query_values'}[$position] = $value;
        }

        $this->_setGlobalVariable ($name, $value);
    }

    function removeParameter ($name) {
        $position = $this->_position($name);

        if ($position != -1) {
            $this->{'data'}->{'query_names'}[$position] = '';
            $this->{'data'}->{'query_values'}[$position] = '';
        }

        $this->_removeGlobalVariable ($name);
    }

    function renameParameter ($old_name, $new_name) {
        $position = $this->_position($old_name);

        if ($position != -1) {
            $old_value = $this->_getGlobalVariable ($old_name);

            $this->setParameter ($new_name, $old_value);
            $this->removeParameter ($old_name);
        }
    }

    function parameterIsPresent ($name) {
        $position = $this->_position($name);

        if ($position != -1) return 1;
        else return 0;
    }

    function _parameterIsCorrect ($name, $value) {
        $capital_letters = 1;
        for ($cntr = 0; $cntr < strlen ($name); $cntr ++) {
             if ($name[$cntr] == '_') continue;
             if (ord ($name[$cntr]) < ord ('A') ||
                 ord ($name[$cntr]) > ord ('Z')) { $capital_letters = 0; break; }
        }
        if ($capital_letters) return 0;

        $national_letters = 0;
        for ($cntr = 0; $cntr < strlen ($name); $cntr ++) {
             if (ord ($name[$cntr]) < ord (' ') ||
                 ord ($name[$cntr]) > ord ('~')) { $national_letters = 1; break; }
        }
        if ($national_letters) return 0;

        $possible_hacker_attack = 0;
        if ($value[0] == '/' || $value[0] == '\\' || $value[0] == '.' || $value[0] == '~') $possible_hacker_attack = 1;
        if ($value[1] == ':') $possible_hacker_attack = 1;
        if ($possible_hacker_attack) {
            if (strpos ($value, 'tmp') || strpos ($value, 'TMP') || strpos ($value, 'Tmp') ||
                strpos ($value, 'temp') || strpos ($value, 'TEMP') || strpos ($value, 'Temp')) $possible_hacker_attack = 0;
        }
        if ($possible_hacker_attack) return 0;

        return 1;
    }

    function _position ($name) {
        for ($cntr = 0; $cntr < count ($this->{'data'}->{'query_names'}); $cntr ++) {
             if ($this->{'data'}->{'query_names'}[$cntr] == $name) return $cntr;
        }

        return -1;
    }
}

$query = new HTMLQuery ();
?>
