<?
/**
 *      Translit-.       .
 */

class Translit {

   function createTranslit ($string_lower_case) {
          $cyrillic = split (' ', '                                ');
          $translit = split (' ', 'a b v g d e io zh z i y k l m n o p r s t u f kh tz ch sh sch \' ui " ae iu ya');

          if (count ($cyrillic) != count ($translit)) return '';

          for ($character = 0; $character < count ($cyrillic); $character ++) 
               $string_lower_case = str_replace ($cyrillic[$character], $translit[$character], $string_lower_case);

          return $string_lower_case;
   }

   function restoreCyrillic ($string_lower_case) {
          for ($token_length = 4; $token_length >= 1; $token_length --) {
               for ($charset = 1; $charset <= 4; $charset ++) {
                    switch ($charset) {
                            case 1:
                                   $cyrillic = split (' ', '                                           ');
                                   $translit = split (' ', 'a b v g d e io yo jo zh zg z i k l m n o p r s t u f ff kh tz tc ts ch sh sch shch \' ui " ae ea iu yu ju ia ya ja');
                            break;

                            case 2:
                                   $cyrillic = split (' ', '                                    ');
                                   $translit = split (' ', 'ay ai aj ey ei ej ioy yoy iy ii ij oy oi oj uy ooy uj uiy yi uij yj yy aey aei aej eay eai eaj iuy iui iuj iay iai iaj yay yai yaj');
                            break;

                            case 3:
                                   $cyrillic = split (' ', ' ');
                                   $translit = split (' ', 'je je');
                            break;

                            case 4:
                                   $cyrillic = split (' ', '      ');
                                   $translit = split (' ', 'c h j q w x y');
                            break;
                    }

                    if (count ($cyrillic) == count ($translit))
                        for ($character = 0; $character < count ($cyrillic); $character ++) 
                             if (strlen ($translit[$character]) == $token_length)
                                 $string_lower_case = str_replace ($translit[$character], $cyrillic[$character], $string_lower_case);
               }
          }

          return $string_lower_case;
   }

}

$translit = new Translit ();
?>